/*
 * Copyright 2000-2001 by Jean-Claude Christophe <jch@oleane.net>
 *                                               <jch@bsdfr.org>
 *
 * Home page:  http://www.bsdfr.org/projects/tac_bsd/
 *
 * misc.c  Some functions used in all others .c files.
 */

#include <sys/types.h>
#include <sys/stat.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <syslog.h>
#include <signal.h>
#include <string.h> /* strncmp(3) */
#include <fcntl.h>
#include <pwd.h>    /* endpwent(3) */

#include "tac_bsd.h"
#include "conf.h"

#define LOCK_FILE "/tmp/tac_bsd.lck"

extern int try;
void logintimeout(int);

void
authen_failed()
{
    /*
     * Same player, shoot again
     */
    endpwent(); /* even if no passwd file are opened */
    try++;
    printf("\nAuthentication failed.\n\n");  
}

/* 
 * check if the user is not in reject_user file 
 * return 1 on invalid account (present in the reject user file
 * 0 if nothing found.
 */
int
checkinvalid(username)
    char *username;
{
    FILE *fp;
    char c[256];

    if (reject_user) {
	/* 
	 * we already check if the file exist in conf.c - file_exist() 
	 */
	fp = fopen(reject_user, "r");
	while (fgets(c, 256, fp)) {
	    if (!strncmp(c, username, strlen(username))) {
		fclose(fp);
		return(1);
	    }
	}
	fclose(fp);
    }
    return(0);
}

/* check if file or directory exist */
int
file_exist(file)
    char *file;
{
    int fd;
    struct stat *sb = (struct stat *)malloc(sizeof(struct stat));

    if ((fd = stat(file, sb)) < 0)
	return(-1);

    return(1);
}


/* get from login.c of standard BSD */
char *
getstring(prompt)
    char *prompt;
{
    int ch;
    char *p;
    static char nbuf[32];

    for (;;) {
	printf("%s", prompt);
	for (p = nbuf; (ch = getchar()) != '\n'; ) {
	    if (ch == EOF) {
	    }
	    if (p < nbuf + (32 - 1))
		*p++ = ch;
	}
	if (p > nbuf) {
	    if (nbuf[0] == '-')
		fprintf(stderr, "login names may not start with '-'.\n");
	    else {
		*p = '\0';
		username = nbuf;
		break;
	    }
	}
    }
    return(nbuf);
}

int
authenticate()
{
    username = getstring("Username: ");
    serv = strstr(username, "@");

    if (checkinvalid(username)) {
	/* 
	 * Account is invalid, however we ask for a password
	 */
	password = getpass("Password: ");
	return(-1);
    }

/*
 * from tac-rfc 1.78, This is not the client who choose
 * the login prompt, but the server.
 *
 * password = getpass("Password: ");
 *
 */

/*    (void)signal(SIGALRM, SIG_IGN);
      (void)alarm(0);*/

    return(1);
}
